function Q = wbaMarcumq(a,b,m)

%initialization
ec  = log(1-4*eps);
bc  = 2*log(b) - log(2);    %constant log(b*b/2)
ac  = 2*log(a) - log(2);    %constant log(a*a/2)

Ld  = -0.5*(a.^2);
Lh  = Ld;
Lf  = m*bc - 0.5*(b.^2) - sum(log(1:m));
Le  = -0.5*(b.^2);
Lx  = -0.5*(b.^2);

k = 1;Q = 1-exp(Lf+Lh);j = 1;
while ((k <= m) | any(j)),
    Ld  = Ld + ac - log(k);
    Lh  = Lh + log(1 + exp(Ld-Lh));
    Lf  = Lf + bc - log(k+m);
    Lx  = Lx + bc - log(k);
    Le  = Le + log(1 + exp(Lx-Le));
    Q   = Q - exp(Lf+Lh);
    j   = (Le < ec) & (Q > 8*eps);
    k   = k + 1;
    if (k > 100000), j = 0;end;
end;

return;